$LOAD_PATH.unshift File.expand_path("./lib")

require 'active_support/core_ext'
require 'logger'
require 'digest/md5'
require 'restclient'

require 'masheri/exceptions'
require 'masheri/config'

require 'masheri/rpc_client'
require 'masheri/rpc_client/base'
require 'masheri/rpc_client/response'

require 'masheri/rest_client'
require 'masheri/query_builder'
require 'masheri/rest_client/query'


require 'masheri/member'
require 'masheri/key'
require 'masheri/service'

module Masheri
  @@config = nil

  def self.config
    raise Masheri::ConfigMissing.new unless @@config.present?
    @@config
  end

  def self.config=(other)
    @@config = other
  end

  def self.load_config!(yaml_file)
    Masheri.config = Masheri::Config.new(yaml_file)
  end

  def self.rpc
    Masheri::RpcClient.new
  end

  def self.rest
    Masheri::RestClient.new
  end

  def self.activity(activity_type, service_id, options)
    Masheri.rest.activity(activity_type, service_id, options)
  end
end

if defined?(Rails)
  require 'masheri/rails'
end
